// 11-Buz.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0 libMyPi2.a
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>
#include <stdlib.h>     //EXIT_SUCCESS
#include <lgpio.h>      //lgGpiochipOpen,lgTxPulse,etc
#include  "MyPi2.h"     //マイライブラリ
#define PI5        4    // /dev/gpiochip4
#define PI4B       0    // /dev/gpiochip0
#define SW_WHITE   27   //白色SW
#define BUZZER     18   //圧電サウンダ

int main (void){
    int hnd;
    int lFlgOut=0;
    int lFlgIn=LG_SET_PULL_NONE;    //内部抵抗を使用しない
    hnd = lgGpiochipOpen(PI5);
    //hnd = lgGpiochipOpen(PI4B);
    lgGpioClaimOutput(hnd,lFlgOut,BUZZER,LG_LOW);   //BUZZERを出力に設定
    lgGpioClaimInput(hnd,lFlgIn,SW_WHITE);          //白色SWを入力に設定

    while(1){
        if(lgGpioRead(hnd, SW_WHITE)==LG_HIGH){     //白色SWが押された
            lgTxPulse(hnd,BUZZER,500,500,0,0);      //1kHzを出力する
        }else{                                      //白色SWが押されてない
            lgTxPulse(hnd,BUZZER,0,0,0,0);          //出力停止
            lgGpioWrite(hnd,BUZZER,LG_LOW);
        }
        lguSleep(0.001);    //CPU使用率の抑制のため 1ms
    }
    lgGpiochipClose(hnd);
    return EXIT_SUCCESS;
}
