// 11-Lcd.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0 libMyPi2.a
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>          //sprintf
#include <stdlib.h>         //EXIT_SUCCESS
#include <lgpio.h>          //lgI2cOpen,etc
#include  "MyPi2.h"         //マイライブラリ
//I2Cバスインタフェース
#define I2C_BUS     1       // /dev/i2c-1
#define LCD_ADR     0x3e    //LCD スレーブアドレス

int main(void){
    int i=0;
    int hndLcd;
    char s1[17];                            //LCD16文字+ヌル文字

    hndLcd = lgI2cOpen(I2C_BUS,LCD_ADR,0);  //LCDのハンドルを取得
    LcdSetup(hndLcd);                       //LCDの初期化

    while(1){
        LcdClear(hndLcd);           //画面クリア
        sprintf(s1,"i=%d",i);       //文字列へ変換
        LcdWriteString(hndLcd,s1);  //LCDに表示
        i++;                        //カウントアップ
        lguSleep(1);                //1秒待つ
    }
    lgI2cClose(hndLcd);
    return EXIT_SUCCESS;
}
