// 11-Shutdown.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0 libMyPi2.a
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>
#include <stdlib.h>     //EXIT_SUCCESS
#include <lgpio.h>      //lgGpiochipOpen,lgGpioRead,etc
#include  "MyPi2.h"     //マイライブラリ
#define PI5     4       // /dev/gpiochip4
#define PI4B    0       // /dev/gpiochip0
#define SW_RED  17      //赤色SW
#define I2C_BUS 1       // /dev/i2c-1
#define LCD_ADR 0x3e    //LCD スレーブアドレス

int main(void){
    int hnd,hndLcd;
    int swStat;                 //赤色SWの値
    int swCnt=0;                //赤色SWのカウンタ
    int lFlgIn=LG_SET_PULL_NONE; //内部抵抗を使用しない
    hnd = lgGpiochipOpen(PI5);
    //hnd = lgGpiochipOpen(PI4B);
    lgGpioClaimInput(hnd,lFlgIn,SW_RED);     //赤色SWを入力に設定

    while(swCnt<3){        //3秒秒待つ
        swStat=lgGpioRead(hnd, SW_RED);
        if(swStat==LG_HIGH){
            swCnt++;        //SWが押されたとき
        }else{
            swCnt=0;        //SWが押されてないとき
        }
        lguSleep(1);        //1秒
    }
    hndLcd = lgI2cOpen(I2C_BUS,LCD_ADR,0);  //LCDのハンドルを取得
    LcdSetup(hndLcd);                       //LCDの初期化
    LcdWriteString(hndLcd,"Shutdown start!");
    system("shutdown -h now");
    lgI2cClose(hndLcd);
    lgGpiochipClose(hnd);
    return EXIT_SUCCESS;
}
