// 11-Sw.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0 libMyPi2.a
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>      //sprintf
#include <stdlib.h>     //EXIT_SUCCESS
#include <lgpio.h>      //lgGpiochipOpen,lgGpioRead,etc
#include  "MyPi2.h"     //マイライブラリ
#define PI5        4    // /dev/gpiochip4
#define PI4B       0    // /dev/gpiochip0
#define SW_RED     17   //赤色SW
#define SW_WHITE   27   //白色SW
#define I2C_BUS    1    // /dev/i2c-1
#define LCD_ADR    0x3e //LCD スレーブアドレス

int main(void){
    int hnd,hndLcd;
    int swNow =0;                   //現在のSWの値
    int swPre = 0b11;               //前回(swPrevious)のSWの値
    char s1[17];                    //LCD16文字+ヌル文字
    int lFlgIn=LG_SET_PULL_NONE;    //内部抵抗を使用しない

    hnd = lgGpiochipOpen(PI5);
    //hnd = lgGpiochipOpen(PI4B);
    lgGpioClaimInput(hnd,lFlgIn,SW_RED);    //赤色SWを入力に設定
    lgGpioClaimInput(hnd,lFlgIn,SW_WHITE);  //白色SWを入力に設定
    hndLcd = lgI2cOpen(I2C_BUS,LCD_ADR,0);  //LCDのハンドルを取得
    LcdSetup(hndLcd);                       //LCDの初期化

    while(1){
        swNow = lgGpioRead(hnd, SW_RED)*2+lgGpioRead(hnd, SW_WHITE);
/* swNow=0b00のとき、Red SW is OFF,White SW is OFF
 * swNow=0b01のとき、Red SW is OFF,White SW is ON
 * swNow=0b10のとき、Red SW is ON, White SW is OFF
 * swNow=0b11のとき、Red SW is ON, White SW is ON */
        if(swNow != swPre){
            LcdClear(hndLcd);
            switch(swNow){
                case 0b00:
                    sprintf(s1,"Red SW is OFF");   //文字列に変換
                    LcdWriteString(hndLcd, s1);    //LCDに表示
                    LcdNewline(hndLcd);            //改行
                    sprintf(s1,"White SW is OFF"); //文字列に変換
                    LcdWriteString(hndLcd, s1);    //LCDに表示
                    swPre = swNow;
                    break;
                case 0b01:
                    sprintf(s1,"Red SW is OFF");
                    LcdWriteString(hndLcd, s1);
                    LcdNewline(hndLcd);
                    sprintf(s1,"White SW is ON");
                    LcdWriteString(hndLcd, s1);
                    swPre = swNow;
                    break;
                case 0b10:
                    sprintf(s1,"Red SW is ON");
                    LcdWriteString(hndLcd, s1);
                    LcdNewline(hndLcd);
                    sprintf(s1,"White SW is OFF");
                    LcdWriteString(hndLcd, s1);
                    swPre = swNow;
                    break;
                case 0b11:
                    sprintf(s1,"Red SW is ON");
                    LcdWriteString(hndLcd, s1);
                    LcdNewline(hndLcd);
                    sprintf(s1,"White SW is ON");
                    LcdWriteString(hndLcd, s1);
                    swPre = swNow;
                    break;
            }
        }
        lguSleep(0.001);    //CPU使用率の抑制のため 1ms
    }
    lgI2cClose(hndLcd);
    lgGpiochipClose(hnd);
    return EXIT_SUCCESS;
}

