// 4-Led02.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>      //printf,fflush
#include <stdlib.h>     //EXIT_SUCCESS
#include <lgpio.h>      //lgGpiochipOpen,lgGpioWrite,etc
#define PI5     4       // /dev/gpiochip4
#define PI4B    0       // /dev/gpiochip0
#define LED0    23      //LED0からLED3までのGPIO番号の定義
#define LED1    22
#define LED2    25
#define LED3    24
#define LNUM    4       //LEDの数

int main (void){
    int hnd;
    int lFlgOut=0;
    int leds[LNUM]={LED0,LED1,LED2,LED3};
    int levels[LNUM]={0,0,0,0};
    uint64_t i;
    uint64_t gMsk=0b1111;
    hnd = lgGpiochipOpen(PI5);
    //hnd = lgGpiochipOpen(PI4B);
    lgGroupClaimOutput(hnd,lFlgOut,LNUM,leds,levels);
    for(i=0;i<16;i++){
        lgGroupWrite(hnd,LED0,i,gMsk);
        printf("%lu ",i);
        fflush(stdout);
        lguSleep(1);                //1秒時間待ち
    }
    lgGroupWrite(hnd,LED0,0,gMsk);  //LEDを消灯
    printf("\nEnd\n");
    lgGpiochipClose(hnd);
    return EXIT_SUCCESS;
}
