// 5-Alt01.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>      //printf
#include <stdlib.h>     //EXIT_SUCCESS
#include <lgpio.h>      //lgGpiochipOpen,lgGpioRead,etc
#define PI5    4        // /dev/gpiochip4
#define PI4B   0        // /dev/gpiochip0
#define LED0   23       //GPIO23をLED0と定義
#define SW0    4        //GPIO4をSW0と定義

int main (void){
    int i=0;
    int hnd;
    int lFlgOut=0;
    int lFlgIn=LG_SET_PULL_DOWN;    //プルダウン抵抗を有効
    int s0Now=0;    //現在のSW0値
    int s0Pre=0;    //一つ前のSW0値
    int alt0=0;     //0または1のオルタネート動作

    hnd = lgGpiochipOpen(PI5);
    //hnd = lgGpiochipOpen(PI4B);
    lgGpioClaimOutput(hnd,lFlgOut,LED0,LG_LOW); //LED0を出力に設定
    lgGpioClaimInput(hnd,lFlgIn,SW0);           //SW0を入力に設定
    while(1){
        s0Pre = s0Now;      //s0Preの更新
        s0Now = lgGpioRead(hnd, SW0);
        if((s0Pre==LG_LOW)&&(s0Now==LG_HIGH)){  //SW0の立ち上がりエッジを検出
            alt0 = !alt0;                       //alt0を論理否定
            lgGpioWrite(hnd,LED0,alt0);         //alt0を出力する
            printf("%d alt0=%d\n",++i,alt0);    //デバッグ用
        }
    }
    lgGpiochipClose(hnd);
    return EXIT_SUCCESS;
}
