// 5-Grp01.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>      //printf
#include <stdlib.h>     //EXIT_SUCCESS
#include <lgpio.h>      //lgGpiochipOpen,lgGroupRead,etc
#define PI5     4       // /dev/gpiochip4
#define PI4B    0       // /dev/gpiochip0
#define SW0     4       //GPIO4をSW0と定義
#define SW1     5
#define SW2     6
#define SW3     26
#define SW4     17
#define SW5     27
#define SW6     20
#define SW7     21
#define SNUM    8       //SWの数
/* プロトタイプ宣言 */
void PrintBinary(uint64_t bits, int msb);

int main (void){
    int hnd;
    int lFlgIn=LG_SET_PULL_DOWN;    //プルダウン抵抗を有効
    int sw70[SNUM] = {SW0,SW1,SW2,SW3,SW4,SW5,SW6,SW7};
    uint64_t bits;
    hnd = lgGpiochipOpen(PI5);
    //hnd = lgGpiochipOpen(PI4B);
    lgGroupClaimInput(hnd, lFlgIn, SNUM, sw70);
    while(1){
        lgGroupRead(hnd, SW0, &bits);
        printf("SW7-0 = 0x%02lx\t",bits);
        PrintBinary(bits,7);
        lguSleep(0.5);
    }
    lgGpiochipClose(hnd);
    return EXIT_SUCCESS;
}

//関数名  void PrintBinary(uint64_t bits, int msb)
//引  数  bits データ
//引  数  msb  最上位ビット 例：byteのmsbはbit7なので、7とする。
//戻り値  なし
//概  要  データbitsを2進数でターミナルに表示する。
void PrintBinary(uint64_t bits, int msb){
    if (msb < 0) {
        printf("\n");
        return;
    }
    printf("%lu",(bits>>msb)%2);
    if((msb%4)==0)printf(" ");          //4桁区切り
    PrintBinary(bits, msb-1);           //再帰呼出し
}
