// 5-Int01.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>
#include <stdlib.h>     //EXIT_SUCCESS
#include <lgpio.h>      //lgGpioSetAlertsFunc,lgGpioClaimAlert,etc
#define PI5     4       // /dev/gpiochip4
#define PI4B    0       // /dev/gpiochip0
#define LED0    23      //GPIO23をLED0と定義
#define LED1    22      //GPIO22をLED1と定義
#define SW0     4       //GPIO4をSW0と定義
#define SW1     5       //GPIO5をSW1と定義
/* プロトタイプ宣言 */
void CbfSw0(int e, lgGpioAlert_p evt, void *userdata);  //SW0の割込み処理の関数
void CbfSw1(int e, lgGpioAlert_p evt, void *userdata);  //SW1の割込み処理の関数
/* グローバル変数 */
int g_hnd;              //handle

int main (void){
    int lFlgOut=0;
    int lFlgIn = LG_SET_PULL_DOWN;      //プルダウン抵抗を有効
    int userdata;
    g_hnd = lgGpiochipOpen(PI5);
    //g_hnd = lgGpiochipOpen(PI4B);
    lgGpioClaimOutput(g_hnd,lFlgOut,LED0,LG_LOW);
    lgGpioClaimOutput(g_hnd,lFlgOut,LED1,LG_LOW);
    lgGpioSetAlertsFunc(g_hnd,SW0,CbfSw0, &userdata);       //SW0の割込み処理関数の設定
    lgGpioSetAlertsFunc(g_hnd,SW1,CbfSw1, &userdata);       //SW1の割込み処理関数の設定
    lgGpioClaimAlert(g_hnd,lFlgIn,LG_RISING_EDGE,SW0,-1);   //SW0の立ち上がりエッジの設定
    lgGpioClaimAlert(g_hnd,lFlgIn,LG_RISING_EDGE,SW1,-1);   //SW1の立ち上がりエッジの設定

    for(;;){
        lgGpioWrite(g_hnd,LED0,LG_HIGH);
        lguSleep(0.5);      //0.5秒待つ
        lgGpioWrite(g_hnd,LED0,LG_LOW);
        lguSleep(0.5);      //0.5秒待つ
    }
    lgGpiochipClose(g_hnd);
    return EXIT_SUCCESS;
}

void CbfSw0(int e, lgGpioAlert_p evt, void *userdata)   //SW0の割込み処理
{
    lgGpioWrite(g_hnd,LED1,LG_HIGH);    //LED1を点灯
}

void CbfSw1(int e, lgGpioAlert_p evt, void *userdata)   //SW1の割込み処理
{
    lgGpioWrite(g_hnd,LED1,LG_LOW);     //LED1を消灯
}

