// 6-Time01.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>
#include <stdlib.h>     //EXIT_SUCCESS
#include <unistd.h>     //usleep
#include <lgpio.h>      //lguTimestamp,etc
#define PI5     4       // /dev/gpiochip4
#define PI4B    0       // /dev/gpiochip0
#define LED0    23
#define LED1    22
#define LED2    25
#define LNUM    3       //LEDの数

int main (void){
    int i,pin;
    double endTime,blinkTime=10.0;
    uint64_t ms;
    int hnd;
    int lFlgOut=0;
    int leds[LNUM]={LED0,LED1,LED2};
    int levels[LNUM]={0,0,0};
    uint64_t gMsk=0b111;
    int cycleHz[LNUM]={1,2,3};  //Hz
    hnd = lgGpiochipOpen(PI5);
    //hnd = lgGpiochipOpen(PI4B);
    lgGroupClaimOutput(hnd,lFlgOut,LNUM,leds,levels);
    endTime=lguTime()+blinkTime;
    while(endTime>lguTime()){
        for(i=0;i<LNUM;i++){
            ms = lguTimestamp()/1000000;        //ミリ秒に変換
            pin=!((int)(ms*2*cycleHz[i]/1000)%2);
            lgGpioWrite(hnd,leds[i],pin);
        }
        usleep(1000);               //CPU使用率の抑制のため 1ms
    }
    lgGroupWrite(hnd,LED0,0,gMsk);  //LEDを全消灯
    lgGpiochipClose(hnd);
    return EXIT_SUCCESS;
}
