// 7-Lcd02.c
// gcc -Wall -o "%e" "%f" -llgpio -lpthread -g -O0 libMyPi2.a
// Geanyのオプションの"%e"は実行ファイル名, "%f"はソースファイル名のこと

#include <stdio.h>     //fprintf
#include <stdlib.h>    //EXIT_SUCCESS
#include <lgpio.h>     //lgI2cOpen,lgI2cClose,etc
#include "MyPi2.h"     //マイライブラリ
//I2Cバスインタフェース
#define I2C_BUS    1    // /dev/i2c-1
#define LCD_ADR    0x3e //LCD スレーブアドレス

int main(int argc, char *argv[]){
    int i;
    int hndLcd,err;
    hndLcd = lgI2cOpen(I2C_BUS,LCD_ADR,0);     //LCDのハンドルを取得
    err=LcdSetup(hndLcd);                      //LCDの初期化
    if(err<0){
        fprintf(stderr,"%s(%d).\n",lguErrorText(err),err);   //エラーメッセージの表示
        lgI2cClose(hndLcd);
        return EXIT_FAILURE;
    }

    if(argc ==1){
        LcdWriteString(hndLcd, "* Hello World! *");    //文字列の表示
        LcdWriteString(hndLcd, "0123456789ABCDEF");
    }else{          //main関数に文字列の引数がある場合の処理
        LcdWriteString(hndLcd, argv[1]);
        for (i=2;i<argc;i++){
            LcdWriteChar(hndLcd, ' ');  //文字列が２つ以上のときに空白を挿入
            LcdWriteString(hndLcd, argv[i]);
        }
    }
    lgI2cClose(hndLcd);
    return EXIT_SUCCESS;
}
